// set the dimensions and margins of the graph
const width = 800;
const height = 500;

// append the svg object to the body of the page
const svg = d3
  .select('#my_dataviz')
  .append('svg')
  .attr('width', width / 2)
  .attr('height', height);

function render(mapData, countryData) {
  var projection = d3
    .geoEqualEarth()
    .fitSize([width / 2, height], mapData);
  var path = d3.geoPath(projection);

  

  const mapColorAttr = 'Num';
  var mapColorScale = d3
    .scaleLinear()
    .domain(
      d3.extent(
        d3.map(StateFile.Num(), (r) => +r[mapColorAttr]),
      ),
    )
    .range(['white', 'blue']);

  //  function getCountryColor(name) {
  //  let entry = countryData.get(name);
  //if (!(entry == undefined)) {
  //return mapColorScale(entry[mapColorAttr]);
  //}
  //return 'grey';
  //}

  svg
    .append('g')
    .selectAll('path')
    .data(mapData.features)
    .join('path')
    // draw each country
    .attr('fill', function (d) {
      return getCountryColor(d.properties.iso3166_2);
    })
    //    .on('mouseover', function (event, data) {
    //      //d3.select(this).attr('fill', 'red');
    //      d3.selectAll(`#${this.id}`)
    //        .attr('fill', 'red')
    //       .attr('r', 20);
    //   })
    //   .on('mouseleave', function (event, data) {
    //      d3.selectAll(`#${this.id}`)
    //       .attr('fill', getCountryColor(data.properties.name))
    //       .attr('r', (d) => rScale(d[rAttr]));
    //   })
    .attr('id', (d) => d.properties.iso3166_2)
    .attr('d', path);

  //const xAttr = 'Fertility Rate';
  //const x = d3
  //  .scaleLinear()
  //  .domain(
  //    d3.extent(
  //      d3.map(countryData.values(), (d) => d[xAttr]),
  //     ),
  //   )
  //    .range([0, width / 2]);

  //  const yAttr = 'Life expectancy';
  //  const y = d3
  //    .scaleLinear()
  //    .domain(
  //      d3.extent(
  //        d3.map(
  //          countryData.values().filter((d) => d[yAttr] > 0),
  //          (d) => d[yAttr],
  //        ),
  //      ),
  //    )
  //    .range([height, 0]);

  //  const plotColorAttr = 'Continent';
  //  const plotColorScale = d3.scaleOrdinal(
  //    d3.schemeCategory10,
  //  );
  //  function getPointColor(d) {
  //    return plotColorScale(d[plotColorAttr]);
  //  }

  const rAttr = 'Num';
  const rScale = d3
    .scaleLinear()
    .domain(
      d3.extent(d3.map(StateFile.Num(), (d) => d[rAttr])),
    )
    .range([0, 221]);
}

//Read the data
const mapUrl =
  'https://raw.githubusercontent.com/holtzy/D3-graph-gallery/master/DATA/us_states_hexgrid.geojson.json';
const AllStatsFile = 'StateFile.csv';
const StateFile = 'StateFile.csv';

function normalizeCountryName(s) {
  return s.replaceAll(' ', '_').toLowerCase();
}

Promise.all([
  d3.json(mapUrl),
  d3.csv(AllStatsFile),
  d3.csv(StateFile),
]).then(([mapData, AllStatsFile, StateFile]) => {
  var countryData = new Map();
  StateFile.forEach((row) => {
    row.iso3166_2 = row.iso3166_2;
    row.Num = +row.Num;
    countryData.set(row.iso3166_2, row.Num);
  });
  //  mapData.features.forEach((f) => {
  //    f.properties.name = normalizeCountryName(
  //      f.properties.name,
  //    );
  //  });
  //  continentData.forEach((row) => {
  //    let name = normalizeCountryName(row.country);
  //    if (countryData.has(name)) {
  //      countryData.get(name).Continent = row.continent;
  //    } else {
  //      console.log('No match found for ', name);
  //    }
  //  });
  console.log(countryData);
  render(mapData, countryData);
});
